Bug 1066337 (CVE-2013-4149) - CVE-2013-4149 qemu: virtio-net: out-of-bounds buffer write on load
Summary: CVE-2013-4149 qemu: virtio-net: out-of-bounds buffer write on load
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2013-4149
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1095683 1095684 1095685 1133850
Blocks: 1036654 1133827
TreeView+ depends on / blocked
 
Reported: 2014-02-18 09:20 UTC by Petr Matousek
Modified: 2019-09-29 13:13 UTC (History)
40 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-09-22 04:56:27 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2014:0927 normal SHIPPED_LIVE Moderate: qemu-kvm security and bug fix update 2014-07-23 20:15:13 UTC
Red Hat Product Errata RHSA-2014:1268 normal SHIPPED_LIVE Moderate: qemu-kvm-rhev security update 2014-09-22 08:00:39 UTC

Description Petr Matousek 2014-02-18 09:20:27 UTC
Michael S. Tsirkin writes:

QEMU 1.3.0 out-of-bounds buffer write in virtio_net_load()@hw/net/virtio-net.c

>         } else if (n->mac_table.in_use) {
>             uint8_t *buf = g_malloc0(n->mac_table.in_use);

We are allocating buffer of size n->mac_table.in_use

>             qemu_get_buffer(f, buf, n->mac_table.in_use * ETH_ALEN);

and read to the n->mac_table.in_use size buffer n->mac_table.in_use *
ETH_ALEN bytes, corrupting memory.

An user able to alter the savevm data (either on the disk or over the wire
during migration) could use this flaw to to corrupt QEMU process memory on
the (destination) host, which could potentially result in arbitrary code
execution on the host with the privileges of the QEMU process.

Upstream fix:
-------------
  -> http://git.qemu.org/?p=qemu.git;a=commit;h=98f93ddd84800f207889491e0b5d851386b459cf

Comment 1 Petr Matousek 2014-02-18 11:02:37 UTC
Statement:

This issue does not affect the versions of kvm package as shipped with
Red Hat Enterprise Linux 5.

This issue does not affect the versions of qemu-kvm package as shipped
with Red Hat Enterprise Linux 6.

Comment 3 Prasad J Pandit 2014-05-08 11:51:20 UTC
Created qemu tracking bugs for this issue:

Affects: fedora-all [bug 1095683]

Comment 4 Fedora Update System 2014-05-16 10:01:23 UTC
qemu-1.6.2-5.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 5 Prasad J Pandit 2014-07-18 13:37:02 UTC
Acknowledgements:

The issues were discovered as part of the state loading code audit performed by Michael S. Tsirkin of Red Hat, Anthony Liguori and Michael Roth.

Comment 6 errata-xmlrpc 2014-07-23 16:15:32 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 7

Via RHSA-2014:0927 https://rhn.redhat.com/errata/RHSA-2014-0927.html

Comment 9 errata-xmlrpc 2014-09-22 04:01:02 UTC
This issue has been addressed in the following products:

  OpenStack 5 for RHEL 7

Via RHSA-2014:1268 https://rhn.redhat.com/errata/RHSA-2014-1268.html


Note You need to log in before you can comment on or make changes to this bug.